
/* The comments in *.c are only in Czech language, sorry */

/* program xpexeso -- hra s 64 kartickami, viz pexdoc-cz nebo pexdoc-eng */
/*************************************************************************/
/* 7.7.1999                                                   Petr Olsak */

/* Tento program je voln en software; mete jej redistribuovat
   anebo modifikovat za podmnek GNU General Public License, kterou 
   publikovala Free Software Foundation. Pouijte verzi 2 tto licence
   nebo (dle vlastnho uven) libovolnou pozdj verzi.

   Tento program je distribuovn s pnm, aby byl uiten, ale
   BEZ DN ZRUKY. Podrobnji viz GNU General Public License.

   Mete dostat kopii GNU General Public License spolen s tmto programem 
   (viz soubor COPYING). Pokud se tak nestalo, napite Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* Tento modul implementuje na prostredi (X Window System) zavisle funkce */
/**************************************************************************/

#include "config.h"
#include "common.h"
#include TEXTY

/* globalni promenne sdilene s modulem base.o */
/**********************************************/

struct MEMPAIR {
  int poloha, hodnota ;
} MEMPAIR;            /* pole pro pamatovane karticky */
extern struct MEMPAIR mem[MAXMEM];  
extern int numM;  
extern int stav[POCETKARET], hodnota[POCETKARET];  
extern int deepM, deepH, pretimewait, timewait, longtimewait;
extern int kecani, zlomyslny, odebrat;
extern int body[MAXGAMER], bodyS, cislotahu;
extern int ng, cg, lock, hrajepocitac, reset, state;

/* potrebne hlavickove soubory */
/*******************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/xpm.h>

#include SADA
#include ATRIBUTY

/* globalni promenne pouze pro modul xpexeso */
/*********************************************/

static int loguj = 0;

static Widget hlavni, obalka, nabidka, konec,
              status, cislo_tahu, hlaseni, karticky,
              zo_nastaveni, o_nastaveni, tl_nastaveni,
              zo_napovedy, okno_napovedy, 
              hraci, o_ppt, ppt, o_vpt, vpt, o_kecy, o_zpusob, o_odebrat,
              o_p1, p1, o_p2, p2, o_p3, p3,
              rolovatko, obsah_napovedy;

static Widget karta[POCETKARET], hrac[MAXGAMER], 
       kectg[3], zpusobtg[2], odebrattg[2];

static int prepinac, jenapoveda=0;
static int kecani0, zlomyslny0, odebrat0;

static XtAppContext kontext_apl;

static Display *displej;
static Pixmap pic[POCETKARET/2 + 1];
static int ispic[POCETKARET/2 + 1];

XpmAttributes   attributes;

char kstring[4*POCETKARET];
char buff[DELKABUFF];
char *shrac[MAXGAMER];
char seznamhracu[DELKABUFF], shraci[DELKABUFF], napoveda[DELKABUFF];

FILE *fn, *logfile;
char *pn = NULL;      /* string pro napovedu */

/* Funkce, pouzite z modulu base.c */
/***********************************/

void VolbaKarty PP(int p), HrajePocitac (), RozdejHru ();

/* Implementace funkci, ktere vyzaduje modul base.c */
/****************************************************/

void Pockej (dsec)
int dsec;
{
  int i;

  for (i=0; i<2*dsec; i++) {
    while (XtAppPending(kontext_apl)) {
      XEvent e;
      XtAppNextEvent(kontext_apl, &e);
      XtDispatchEvent(&e);
    }
    usleep (50000);
  }
} 

void Kecej (level, s)
int level;
char *s;
{
  Arg atributy[1];

  if (loguj && s[0]) fprintf (logfile, "%s\n", s); 
  if (kecani < level) return;
  XtSetArg (atributy[0], XtNlabel, s);
  XtSetValues (hlaseni, atributy, XtNumber(atributy));  
}

void UkazStav ()
{
  sprintf (buff, KECY00,  deepH/2, deepM/2);
  Kecej (0, buff);
}

void Piskni ()
{
  XBell (displej, 100);
  return;
}

void KonecHry ()
{
  int i, maxbody, vyhral;
  Arg atributy[1];

  if (ng <= 1) Kecej (0, KECY01);
  else {
    maxbody = 0; vyhral = -1;
    for (i=0; i<ng; i++)  if (body[i] > maxbody) {
      maxbody = body[i];
      vyhral = i;
    }
    for (i=0; i<ng; i++)  if (body[i]==maxbody && i!=vyhral) {
      vyhral = -1;
      break;
    }
    if (vyhral >= 0) {
      sprintf (buff, KECY02, shrac[vyhral]);
      Kecej (0, buff);
    }
    else Kecej (0, KECY03);
  }
  hrajepocitac = lock = 0;
  if (loguj) {
    fprintf (logfile, LOG01);
    for (i=0; i<ng; i++) fprintf (logfile, " %s: %d b,", shrac[i], body[i]);
    fprintf (logfile, "\n"); fflush (logfile);
  }
  for (i=0; i<POCETKARET; i++) {
    XtSetArg (atributy[0], XtNbitmap, pic[hodnota[i]]);
    XtSetValues (karta[i], atributy, XtNumber(atributy));
  }  
}

void UkazBody ()
{
  Arg atributy[1];
  int i;

  for (i=0; i<ng; i++) {
    sprintf (buff, HRAC00, shrac[i], body[i]);
    XtSetArg (atributy[0], XtNlabel, buff);
    XtSetValues (hrac[i], atributy, XtNumber(atributy));  
  }
}  

void Ukaz (p)
int p;
{
  Arg atributy[1];
  int j;

  if (loguj) fprintf (logfile, LOG03, 
	      p/POCETSLOUPCU+1, p%POCETSLOUPCU+1, p, logpic[hodnota[p]]); 
  j = hodnota[p];
  if (!ispic[j]) { 
    XpmCreatePixmapFromData (displej, XtWindow(hlavni), spic[j],
			     &pic[j], NULL, &attributes);
    ispic[j] = 1;
  }
  XtSetArg (atributy[0], XtNbitmap, pic[j]);
  XtSetValues (karta[p], atributy, XtNumber(atributy));  
  stav[p] = VIDITELNA;
  /*  while (XtAppPeekEvent(kontext_apl, &event)) {
    XtAppNextEvent (kontext_apl, &event); 
    XtDispatchEvent (&event);
  } */
}

void Zakryj (p)
int p;
{
  Arg atributy[1];

  XtSetArg (atributy[0], XtNbitmap, pic[0]);
  XtSetValues (karta[p], atributy, XtNumber(atributy));  
  stav[p] = ZAKRYTA;
  /*  while (XtAppPeekEvent(kontext_apl, &event)) {
    XtAppNextEvent (kontext_apl, &event);
    XtDispatchEvent (&event);
  } */
}

void Odstran (p)
int p;
{
  Arg atributy[2];

  stav[p] = ODSTRANENA;
  if (!odebrat) return;
  XtSetArg (atributy[0], XtNbitmap, NULL);
  XtSetArg (atributy[1], XtNlabel, "");
  XtSetValues (karta[p], atributy, XtNumber(atributy));  
}

void NovyHrac (h)
int h;
{
  Arg atributy[1];
  Pixel barva;
  int i;

  if (h >= 0) cg = h;
  else {
    cg++;
    if (cg >= ng) cg = 0;
  }
  if (loguj) fprintf (logfile, LOG04, shrac[cg]);
  XtSetArg (atributy[0], XtNbackground, (XtArgVal) &barva);
  XtGetValues (nabidka, atributy, 1); 
  XtSetArg (atributy[0], XtNbackground, (XtArgVal) barva);
  for (i=0; i<ng; i++) XtSetValues (hrac[i], atributy, 1);
  XtSetArg (atributy[0], XtNbackground, &barva);
  XtGetValues (konec, atributy, 1); 
  XtSetArg (atributy[0], XtNbackground, barva);
  XtSetValues (hrac[cg], atributy, 1); 
}

void TiskPameti ()
{
  int i, deep;
  
  deep = MIN (numM, deepM);
  fprintf (logfile, LOG05, deep);
  for (i=1; i<=deep; i++) {
    if (i == deepH+1) fprintf (logfile, LOG06);
    if (mem[numM-i].hodnota) 
      fprintf(logfile, "%d:%s, ",  
	      mem[numM-i].poloha, logpic[mem[numM-i].hodnota]);
    else fprintf(logfile, "%d:-, ", mem[numM-i].poloha);
  }
  fprintf (logfile, "\n");
}

void NovyTah ()
{
  Arg atributy[1];
  int i;

  cislotahu++;
  if (loguj) {
    fprintf (logfile, LOG07, cislotahu);
    for (i=0; i<ng; i++) fprintf (logfile, LOG02, shrac[i], body[i]);
    fprintf (logfile, LOG08, bodyS);
    TiskPameti ();
    fflush (logfile);
  }
  sprintf (buff, TAH00, cislotahu);
  XtSetArg (atributy[0], XtNlabel, buff);
  XtSetValues (cislo_tahu, atributy, XtNumber(atributy));  
}  

void NoviHraci ()
{
  int i=0, j=0;
  
  while (seznamhracu[i] == ' ') i++;
  if (seznamhracu[i]==0) strcpy (shraci, "Samot");
  else strcpy (shraci, seznamhracu);
  i = 0;
  while (j<MAXGAMER) {
    while (shraci[i] == ' ') i++;
    if (shraci[i] == 0) break;
    shrac[j++] = &shraci[i];
    while (shraci[i] != ' ' && shraci[i] != 0) i++;
    if (shraci[i] == 0) break;
    shraci[i++] = 0;
  }
  for (i=0; i< ng; i++)  XtUnmanageChild (hrac[i]);
  ng = j;
  for (i=0; i<ng; i++)  XtManageChild (hrac[i]); 
}


/* Implementace samotneho programu */
/***********************************/

void Usage ()
{
  fprintf (stderr, 
"usage: xpexeso [X11-options] [program-options]\n\
   program options: [-log logfile | -log -]\n\
                    [-doc docfile]\n\
                    [-players \"list of players\"]\n\
                    [-m1 good_memory] [-m2 all_memory]\n\
                    [-t1 pretimewait] [-t2 btimewait] [-t3 ltimewait]\n\
                    [-talk level] [-close-game] [-no-move-out]\n");
  exit (1);
}


void CtiArgumenty (argc, argv)
int argc;
char **argv;
{
  int i;

  for (i=1; i<argc; i++) {
    if (strcmp (argv[i], "-log")==0) {  /* -log logfile */
      i++;  if (i >= argc || loguj) Usage ();
      if (strcmp (argv[i], "-")==0) logfile = stdout;
      else logfile = fopen (argv[i], "w");
      if (logfile == NULL) {
	fprintf (stderr, "Cannot write to log file %s\n", argv[i]);
	exit (1);
      }
      loguj = 1;
    }
    else if (strcmp (argv[i], "-doc")==0) {    /* -doc docfile */
      i++;  if (i >= argc) Usage ();
      strcpy (napoveda, argv[i]);
    }
    else if (strcmp (argv[i], "-players")==0) { /* -players "list" */
      i++;  if (i >= argc) Usage ();
      strcpy (seznamhracu, argv[i]);
    }
    else if (strcmp (argv[i], "-m1")==0) { /* -m1 good_memory */
      i++;  if (i >= argc) Usage ();
      deepH = 2 * atoi (argv[i]);
    }
    else if (strcmp (argv[i], "-m2")==0) { /* -m2 all_memory */
      i++;  if (i >= argc) Usage ();
      deepM = 2 * atoi (argv[i]);
    }
    else if (strcmp (argv[i], "-t1")==0) { /* -t1 pretimewait */
      i++;  if (i >= argc) Usage ();
      pretimewait = atoi (argv[i]);
    }
    else if (strcmp (argv[i], "-t2")==0) { /* -t2 stimewait */
      i++;  if (i >= argc) Usage ();
      timewait = atoi (argv[i]);
    }
    else if (strcmp (argv[i], "-t3")==0) { /* -t3 ltimewait */
      i++;  if (i >= argc) Usage ();
      longtimewait = atoi (argv[i]);
    }
    else if (strcmp (argv[i], "-talk")==0) { /* -talk level */
      i++;  if (i >= argc) Usage ();
      kecani = atoi (argv[i]);
    }
    else if (strcmp (argv[i], "-close-game")==0) { /* -close-game */
      zlomyslny = 1;
    }
    else if (strcmp (argv[i], "-no-move-out")==0) { /* -no-move-out */
      odebrat = 0;
    }
    else Usage ();
  }
  if (deepH < 0) deepH = 0;
  if (deepM < deepH)  deepM = deepH;
  if (pretimewait < 0) pretimewait = PRETIMEWAIT;
  if (timewait < 0) timewait = TIMEWAIT;
  if (longtimewait < 0) longtimewait = LONGTIMEWAIT;
  if (kecani < 0) kecani = 0;
  if (kecani > 2) kecani = 2;
  if (loguj) {
    fprintf (logfile, LOG09, deepH, deepM);
    fprintf (logfile, LOG10, pretimewait, timewait, longtimewait);
    fprintf (logfile, LOG11, zlomyslny, kecani, odebrat);
    fprintf (logfile, LOG12, seznamhracu);
  }
}


static Widget VytvorTlacitko (rodic, jmeno, funkce, apl_data)
Widget rodic;
String jmeno;
XtCallbackProc funkce;
XtPointer apl_data;
{
  Widget pripravek;  
  pripravek = XtCreateManagedWidget (jmeno, commandWidgetClass,
					    rodic, (Arg *) NULL, ZERO);
  XtAddCallback (pripravek, XtNcallback, funkce, apl_data);
  return pripravek;
}


static void InitializePixmaps ()
{
  Arg atributy[1];
  int i;

  XpmCreatePixmapFromData (displej, XtWindow(hlavni), spic[0],
			   &pic[0], NULL, &attributes);
  for (i=1; i<33; i++) ispic[i] = 0;
  ispic[0] = 1;
  prepinac = 0;

  XtSetArg (atributy[0], XtNbitmap, pic[0]);
  for (i=0; i<POCETKARET; i++) XtSetValues (karta[i], atributy, XtNumber(atributy));
  XtSetArg (atributy[0], XtNiconPixmap, pic[0]);
  XtSetValues (hlavni, atributy, XtNumber(atributy));
  XtSetValues (zo_napovedy, atributy, XtNumber(atributy));
  XtSetValues (zo_nastaveni, atributy, XtNumber(atributy));
}

static void Akce (w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  VolbaKarty ((int) client_data);
  return;
}

static void Konec (w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
   exit (0);
}

static void Znova (w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  Arg atributy[1];
  int i;

  if (lock) { Piskni ();  return; }
  RozdejHru ();
  XtSetArg (atributy[0], XtNbitmap, pic[0]);
  for (i=0; i<POCETKARET; i++) 
    XtSetValues (karta[i], atributy, XtNumber(atributy));
}

static void HrejHraci (w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  int i;

  if (hrajepocitac || state != 0) { Piskni ();  return; }
  reset = 1;
  i = (int) client_data;
  state = 0;
  NovyHrac(i);
  lock = 0;
}

static void Napoveda (w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  Arg atributy[2];
  int i;

  if (jenapoveda) { Piskni (); return; }
  if (pn == NULL) {
    fn = fopen (napoveda, "r");
    if (fn == NULL) {
      pn = XtMalloc (2*DELKABUFF);
      strcpy (pn, HELP00);  strcat (pn, napoveda);  
      strcat (pn, HELP01);  strcat (pn, HELP02);  strcat (pn, HELP03);
    }
    else {
      fseek (fn, 0, SEEK_END);
      i = ftell (fn);
      rewind (fn);
      pn = XtMalloc (i+1);
      fread (pn, 1, i, fn);
      pn[i] = 0;
      fclose (fn);
    }
    XtSetArg (atributy[0], XtNlabel, pn);
    XtSetValues (obsah_napovedy, atributy, 1);
  }
  XtPopup (zo_napovedy, XtGrabNone);
  jenapoveda = 1;
}

static void KonecNapovedy (w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  XtPopdown (zo_napovedy);
  jenapoveda = 0;
}

static void KonecNastaveni (w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  Arg atributy[1];
  String input;
  int k;
  
  k = (int) client_data;
  if (k == 0) {
    XtPopdown (zo_nastaveni);
    return;
  }
  
  XtSetArg (atributy[0], XtNstring, (XtArgVal) &input);
  XtGetValues (hraci, atributy, XtNumber(atributy));
  strcpy (seznamhracu, input);
  NoviHraci ();
  UkazBody ();
  XtGetValues (ppt, atributy, XtNumber(atributy));
  deepH = atoi(input) * 2 ;
  XtGetValues (vpt, atributy, XtNumber(atributy));
  deepM = atoi(input) * 2 ;
  XtGetValues (vpt, atributy, XtNumber(atributy));
  deepM = atoi(input) * 2 ;
  XtGetValues (p1, atributy, XtNumber(atributy));
  pretimewait = atoi(input);
  XtGetValues (p2, atributy, XtNumber(atributy));
  timewait = atoi(input);
  XtGetValues (p3, atributy, XtNumber(atributy));
  longtimewait = atoi(input);
  zlomyslny = zlomyslny0;
  kecani = kecani0;
  odebrat = odebrat0;
  if (deepM < deepH) deepM = deepH; 
  if (loguj) {
    fprintf (logfile, LOG13, deepH, deepM);
    fprintf (logfile, LOG10, pretimewait, timewait, longtimewait);
    fprintf (logfile, LOG11, zlomyslny, kecani, odebrat);
    fprintf (logfile, LOG12, seznamhracu);
  }
  UkazStav ();
  if (k < 2) XtPopdown (zo_nastaveni);
}

static void PrepniKecani (w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  Arg atributy[1];
  Pixel barva;
  int i;

  kecani0 = (int) client_data;
  XtSetArg (atributy[0], XtNbackground, (XtArgVal) &barva);
  XtGetValues (nabidka, atributy, 1); 
  XtSetArg (atributy[0], XtNbackground, (XtArgVal) barva);
  for (i=0; i<3; i++) XtSetValues (kectg[i], atributy, 1);
  XtSetArg (atributy[0], XtNbackground, &barva);
  XtGetValues (konec, atributy, 1); 
  XtSetArg (atributy[0], XtNbackground, barva);
  XtSetValues (kectg[kecani0], atributy, 1); 
}

static void PrepniZpusob (w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  Arg atributy[1];
  Pixel barva;
  int i;

  zlomyslny0 = (int) client_data;
  XtSetArg (atributy[0], XtNbackground, (XtArgVal) &barva);
  XtGetValues (nabidka, atributy, 1); 
  XtSetArg (atributy[0], XtNbackground, (XtArgVal) barva);
  for (i=0; i<2; i++) XtSetValues (zpusobtg[i], atributy, 1);
  XtSetArg (atributy[0], XtNbackground, &barva);
  XtGetValues (konec, atributy, 1); 
  XtSetArg (atributy[0], XtNbackground, barva);
  XtSetValues (zpusobtg[zlomyslny0], atributy, 1); 
}

static void PrepniOdebrat (w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  Arg atributy[1];
  Pixel barva;
  int i;

  odebrat0 = (int) client_data;
  XtSetArg (atributy[0], XtNbackground, (XtArgVal) &barva);
  XtGetValues (nabidka, atributy, 1); 
  XtSetArg (atributy[0], XtNbackground, (XtArgVal) barva);
  for (i=0; i<2; i++) XtSetValues (odebrattg[i], atributy, 1);
  XtSetArg (atributy[0], XtNbackground, &barva);
  XtGetValues (konec, atributy, 1); 
  XtSetArg (atributy[0], XtNbackground, barva);
  XtSetValues (odebrattg[odebrat0], atributy, 1); 
}

static void Nastaveni (w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  Arg atributy[1];

  XtSetArg (atributy[0], XtNstring, (XtArgVal) seznamhracu);
  XtSetValues (hraci, atributy, XtNumber(atributy));
  sprintf (buff, "%d", deepH/2);
  XtSetArg (atributy[0], XtNstring, (XtArgVal) buff);
  XtSetValues (ppt, atributy, XtNumber(atributy));
  sprintf (buff, "%d", deepM/2);
  XtSetArg (atributy[0], XtNstring, (XtArgVal) buff);
  XtSetValues (vpt, atributy, XtNumber(atributy));
  sprintf (buff, "%d", pretimewait);
  XtSetArg (atributy[0], XtNstring, (XtArgVal) buff);
  XtSetValues (p1, atributy, XtNumber(atributy));
  sprintf (buff, "%d", timewait);
  XtSetArg (atributy[0], XtNstring, (XtArgVal) buff);
  XtSetValues (p2, atributy, XtNumber(atributy));
  sprintf (buff, "%d", longtimewait);
  XtSetArg (atributy[0], XtNstring, (XtArgVal) buff);
  XtSetValues (p3, atributy, XtNumber(atributy));
  PrepniKecani (NULL, kecani, NULL);
  PrepniZpusob (NULL, zlomyslny, NULL);
  PrepniOdebrat (NULL, odebrat, NULL);

  XtPopup (zo_nastaveni, XtGrabNone);
}

static void VytvorRozhrani (rodic)
Widget rodic;
{
  int i;

  obalka = XtCreateManagedWidget ("hlavniSchranka", formWidgetClass,
					   rodic, (Arg *) NULL, ZERO);
  nabidka = XtCreateManagedWidget ("nabidka", boxWidgetClass,
                                           obalka, (Arg *) NULL, ZERO);
  konec = VytvorTlacitko (nabidka, "konec", Konec, (XtPointer) NULL); 
  VytvorTlacitko (nabidka, "znova", Znova, (XtPointer) NULL);
  VytvorTlacitko (nabidka, "nastaveni", Nastaveni, (XtPointer) NULL);
  VytvorTlacitko (nabidka, "napoveda", Napoveda, (XtPointer) NULL);
  hlaseni = XtCreateManagedWidget ("hlaseni", labelWidgetClass,
				   obalka, (Arg *) NULL, ZERO);
  status = XtCreateManagedWidget ("status", boxWidgetClass,
				  obalka, (Arg *) NULL, ZERO);
  cislo_tahu =  XtCreateManagedWidget ("cislo_tahu", labelWidgetClass,
				       status, (Arg *) NULL, ZERO);
  for (i=0; i<MAXGAMER; i++) {
    hrac[i] = XtCreateWidget ("hrac", commandWidgetClass,
			      status, (Arg *) NULL, ZERO);
    XtAddCallback (hrac[i], XtNcallback, HrejHraci, (XtPointer)i);
  }
  karticky = XtCreateManagedWidget ("karticky", formWidgetClass,
                                 obalka, (Arg *) NULL, ZERO);

  for (i=0; i<POCETKARET; i++) {
    sprintf (&kstring[4*i], "k%d", i);
    karta[i] = XtCreateManagedWidget (&kstring[4*i], commandWidgetClass,
				      karticky, velikost_karticky, 2);
    XtAddCallback (karta[i], XtNcallback, Akce, (XtPointer) i);
  }

  /* napoveda */
  zo_napovedy = XtCreatePopupShell ("xpexeso_napoveda", wmShellWidgetClass, 
				    obalka, (Arg *) NULL, ZERO);
  okno_napovedy = XtCreateManagedWidget ("okno_napovedy", boxWidgetClass, 
					 zo_napovedy, (Arg *) NULL, ZERO);
  VytvorTlacitko (okno_napovedy, "ukoncit_napovedu", 
		  KonecNapovedy, (XtPointer) NULL);
  rolovatko = XtCreateManagedWidget ("rolovatko", viewportWidgetClass,
				     okno_napovedy, (Arg *) NULL, ZERO);
  obsah_napovedy = XtCreateManagedWidget ("obsah_napovedy", labelWidgetClass,
				     rolovatko, (Arg *) NULL, ZERO);

  /* nastaveni */
  zo_nastaveni = XtCreatePopupShell ("xpexeso_nastaveni", 
				     wmShellWidgetClass, obalka, 
				     (Arg *) NULL, ZERO);
  o_nastaveni = XtCreateManagedWidget ("o_nastaveni", 
				       boxWidgetClass,  zo_nastaveni, 
				       (Arg *) NULL, ZERO);
  tl_nastaveni = XtCreateManagedWidget ("tl_nastaveni", boxWidgetClass,  
				        o_nastaveni,  (Arg *) NULL, ZERO);
  VytvorTlacitko (tl_nastaveni, "potvrdit",  KonecNastaveni, (XtPointer) 1);
  VytvorTlacitko (tl_nastaveni, "potvrdit0",  KonecNastaveni, (XtPointer) 2);
  VytvorTlacitko (tl_nastaveni, "ustup", KonecNastaveni, (XtPointer) 0);
  XtCreateManagedWidget ("n_hraci", labelWidgetClass,  
				   o_nastaveni,  (Arg *) NULL, ZERO);
  hraci = XtCreateManagedWidget ("hraci", asciiTextWidgetClass,
				 o_nastaveni, (Arg *) NULL, ZERO);
  XtCreateManagedWidget ("n_automat", labelWidgetClass,  
			 o_nastaveni,  (Arg *) NULL, ZERO);
  o_ppt = XtCreateManagedWidget ("o_ppt", boxWidgetClass,  o_nastaveni,
				 (Arg *) NULL, ZERO);
  XtCreateManagedWidget ("n_ppt", labelWidgetClass,  
			 o_ppt,  (Arg *) NULL, ZERO); 
  ppt = XtCreateManagedWidget ("ppt", asciiTextWidgetClass,
			       o_ppt, (Arg *) NULL, ZERO);
  o_vpt = XtCreateManagedWidget ("o_vpt", boxWidgetClass,  o_nastaveni,
				 (Arg *) NULL, ZERO);
  XtCreateManagedWidget ("n_vpt", labelWidgetClass,  
			 o_vpt,  (Arg *) NULL, ZERO); 
  vpt = XtCreateManagedWidget ("vpt", asciiTextWidgetClass,
			       o_vpt, (Arg *) NULL, ZERO);
  o_zpusob = XtCreateManagedWidget ("o_zpusob", boxWidgetClass,  o_nastaveni,
				 (Arg *) NULL, ZERO);
  XtCreateManagedWidget ("n_zpusob", labelWidgetClass,  
			 o_zpusob,  (Arg *) NULL, ZERO); 
  zpusobtg[0] = VytvorTlacitko (o_zpusob, "otevrena", 
				PrepniZpusob, (XtPointer) 0);
  zpusobtg[1] = VytvorTlacitko (o_zpusob, "zlomyslna", 
				PrepniZpusob, (XtPointer) 1);
  o_kecy = XtCreateManagedWidget ("o_kecy", boxWidgetClass,  o_nastaveni,
				 (Arg *) NULL, ZERO);
  XtCreateManagedWidget ("n_kecy", labelWidgetClass,  
			 o_kecy,  (Arg *) NULL, ZERO); 
  kectg[0] = VytvorTlacitko (o_kecy, "mlci", 
			     PrepniKecani, (XtPointer) 0);
  kectg[1] = VytvorTlacitko (o_kecy, "komentuje_sebe", 
			     PrepniKecani, (XtPointer) 1);
  kectg[2] = VytvorTlacitko (o_kecy, "kibicuje", 
			     PrepniKecani, (XtPointer) 2);
  XtCreateManagedWidget ("n_prodlevy", labelWidgetClass,  
			 o_nastaveni,  (Arg *) NULL, ZERO); 
  o_p1 = XtCreateManagedWidget ("o_p1", boxWidgetClass,  o_nastaveni,
				(Arg *) NULL, ZERO);
  XtCreateManagedWidget ("n_p1", labelWidgetClass,  
			 o_p1,  (Arg *) NULL, ZERO); 
  p1 = XtCreateManagedWidget ("p1", asciiTextWidgetClass,
			      o_p1, (Arg *) NULL, ZERO);
  o_p2 = XtCreateManagedWidget ("o_p2", boxWidgetClass,  o_nastaveni,
				(Arg *) NULL, ZERO);
  XtCreateManagedWidget ("n_p2", labelWidgetClass,  
			 o_p2,  (Arg *) NULL, ZERO); 
  p2 = XtCreateManagedWidget ("p2", asciiTextWidgetClass,
			      o_p2, (Arg *) NULL, ZERO);
  o_p3 = XtCreateManagedWidget ("o_p3", boxWidgetClass,  o_nastaveni,
				(Arg *) NULL, ZERO);
  XtCreateManagedWidget ("n_p3", labelWidgetClass,  
			 o_p3,  (Arg *) NULL, ZERO); 
  p3 = XtCreateManagedWidget ("p3", asciiTextWidgetClass,
			      o_p3, (Arg *) NULL, ZERO);
  o_odebrat = XtCreateManagedWidget ("o_odebrat", boxWidgetClass, o_nastaveni,
				     (Arg *) NULL, ZERO);
  XtCreateManagedWidget ("n_odebrat", labelWidgetClass,  
			 o_odebrat,  (Arg *) NULL, ZERO); 
  odebrattg[1] = VytvorTlacitko (o_odebrat, "odebrat", 
				 PrepniOdebrat, (XtPointer) 1);
  odebrattg[0] = VytvorTlacitko (o_odebrat, "ponechat", 
				PrepniOdebrat, (XtPointer) 0);
}

int main (argc, argv)
int argc;
char **argv;
{
  XEvent e;

  hlavni = XtAppInitialize (&kontext_apl, "Xpexeso",
			    (XrmOptionDescRec *) NULL, ZERO, &argc, argv,
			    implicitni_atributy, (Arg *) NULL, ZERO);
  logfile = stdout;
  strcpy (seznamhracu, HRACI);
  strcpy (napoveda, NAPOVEDA);
  if (argc != 1)  CtiArgumenty (argc, argv);

  VytvorRozhrani (hlavni);
  XtRealizeWidget (hlavni);

  displej = XtDisplay (hlavni);
  attributes.valuemask = XpmColormap;
  attributes.colormap = XDefaultColormap(displej, 0);
  InitializePixmaps (); 

  ng = 0;
  NoviHraci ();
  RozdejHru ();

  while (1) {  /* Hlavni cyklus */
    if (shrac[cg][0] == '@' && bodyS < 32) {
      lock = 1;
      HrajePocitac (); 
      if (shrac[cg][0] != '@') lock = 0;
      state = 0;
    }
    XtAppNextEvent(kontext_apl, &e);
    XtDispatchEvent(&e);
  }
  /*  XtAppMainLoop (kontext_apl); */
  return 0;
}
